"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.progressStatuses = exports.progressProps = void 0;
var _type = require("../_util/type");
var progressStatuses = ['normal', 'exception', 'active', 'success'];
exports.progressStatuses = progressStatuses;
var ProgressType = ['line', 'circle', 'dashboard'];
var ProgressSize = ['default', 'small'];
var progressProps = function progressProps() {
  return {
    prefixCls: String,
    type: (0, _type.stringType)(),
    percent: Number,
    format: (0, _type.functionType)(),
    status: (0, _type.stringType)(),
    showInfo: {
      type: Boolean,
      default: undefined
    },
    strokeWidth: Number,
    strokeLinecap: (0, _type.stringType)(),
    strokeColor: (0, _type.anyType)(),
    trailColor: String,
    width: Number,
    success: (0, _type.objectType)(),
    gapDegree: Number,
    gapPosition: (0, _type.stringType)(),
    size: (0, _type.stringType)(),
    steps: Number,
    /** @deprecated Use `success` instead */
    successPercent: Number,
    title: String
  };
};
exports.progressProps = progressProps;